# syntax=docker/dockerfile:1

FROM python:3.10 as compile-sphinx5.3.0-base

RUN apt-get update

RUN apt-get install -y python3-sphinx
RUN pip install Sphinx==5.3.0 pydata-sphinx-theme==0.12.0
WORKDIR /app/
ENV v6root=/app/data/
RUN mkdir ${v6root}


FROM compile-sphinx5.3.0-base as compile-latest

COPY base.requirements.txt base.requirements.txt
RUN pip install -r base.requirements.txt
COPY requirements.txt requirements.txt
RUN pip install -r requirements.txt
COPY docs/Makefile docs/Makefile
COPY v6d3music v6d3music
COPY docs/source docs/source
WORKDIR /app/docs/
RUN make html


FROM node:19

RUN npm install -g http-server
WORKDIR /app/docs/build/html/
COPY --from=compile-latest /app/docs/build/html/ /app/docs/build/html/
CMD [ "http-server", "-p", "80" ]
